



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MS SQL 模仿ORACLE的DESC</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MS SQL 模仿ORACLE的DESC</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 12:53:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前言： 在ORACLE数据库的SQL*PLUS里面有个DES(DESCRIBE)命令,它可以返回数据库所存储对象的描述,如下所示</p>
<div>
<div>
<pre class="prettyprint linenums">SQL&gt; DESC STUDENT_SCORE</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">Name             Type       Nullable Default Comments</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">---------------- ---------- -------- ------- --------</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">STUDENT_NO       NUMBER(10)                  学号    </pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">CHINESE_SCORE    NUMBER     Y                语文成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">ENGLISH_SCORE    NUMBER     Y                英语成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">MATH_SOCRE       NUMBER     Y                数学成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">PHYSICAL_SCORE   NUMBER     Y                物理成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">SPORTS_SCORE     NUMBER     Y                体育成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">CHEMICAL_SCORE   NUMBER     Y                化学成绩</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">BIOLOGICAL_SCORE NUMBER     Y                生物成绩</pre>
</div>
</div>
<p>DESC可以获取表、视图等的字段名、字段类型、以及字段注释等信息。在开发过程中，这个命令非常实用，方便，也是使用频率比较高的命令，在MS SQL中没有这个命令，倒是有个sp_help命令，也比较方便，获取的信息甚至比DESC命令还多，但是它有个缺陷，不能获取字段的注释信息，有时候给你来一堆你不想关注的信息。下面我们我们来创建一个存储过程，模拟实现DESC命令的功能以及定制一些你想要的功能。希望这个存储过程能方便大家的工作。初版代码如下：</p>
<div>
<div>
<div>sp_desc</div>
<div>
<ol><li>SET&nbsp;ANSI_NULLS&nbsp;ON;</li>
<li>GO</li>
<li>SET&nbsp;QUOTED_IDENTIFIER&nbsp;ON</li>
<li>GO</li>
<li>IF&nbsp;&nbsp;EXISTS(SELECT&nbsp;1&nbsp;FROM&nbsp;sysobjects&nbsp;WHEREid=OBJECT_ID(N'sp_desc')</li>
<li>AND&nbsp;OBJECTPROPERTY(id,&nbsp;'IsProcedure')&nbsp;=1)</li>
<li>DROP&nbsp;PROCEDURE&nbsp;sp_desc;</li>
<li>GO</li>
<li>--==================================================================================================</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ProcedureName&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; sp_desc</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Author&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Kerry</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; CreateDate&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2013-05-13</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Blog&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; www.cnblogs.com/kerrycode/</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Description&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 模仿ORACLE的SQLPLUS命令DESC，并且参考sp_help相关</li>
<li>--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 增强功能</li>
<li>/***************************************************************************************************</li>
<li>Parameters&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 参数说明</li>
<li>****************************************************************************************************</li>
<li>@ObjName&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 需要查看的对象名称，例如表名、视图等</li>
<li>****************************************************************************************************</li>
<li>Modified Date&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Modified User&nbsp;&nbsp;&nbsp;&nbsp; Version&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Modified Reason</li>
<li>****************************************************************************************************</li>
<li>2013-05-19&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Kerry&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; V01.00.01&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 增加Print信息，提示输出内容</li>
<li>***************************************************************************************************/</li>
<li>--==================================================================================================</li>
<li>CREATE&nbsp;PROCEDURE&nbsp;sp_desc</li>
<li>(</li>
<li>@ObjName&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;VARCHAR(32)</li>
<li>)</li>
<li>AS</li>
<li>SET&nbsp;NOCOUNT&nbsp;ON;</li>
<li>DECLARE&nbsp;@ObjectId&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;INT;</li>
<li>DECLARE&nbsp;@Sysobj_Type&nbsp;&nbsp;&nbsp;&nbsp;CHAR(2);</li>
<li>IF&nbsp;@ObjName&nbsp;IS&nbsp;NULL</li>
<li>BEGIN</li>
<li>PRINT&nbsp;'you must assign the parameter @ObjNam';</li>
<li>RETURN&nbsp;0;</li>
<li>END</li>
<li>SELECT&nbsp;@ObjectId&nbsp;=&nbsp;object_id,&nbsp;@Sysobj_Type=type&nbsp;FROM&nbsp;sys.all_objects</li>
<li>WHERE&nbsp;object_id&nbsp;=OBJECT_ID(@ObjName);</li>
<li>IF&nbsp;@Sysobj_Type&nbsp;='U'&nbsp;AND&nbsp;@ObjectId&nbsp;&gt;&nbsp;0</li>
<li>BEGIN</li>
<li>SELECT&nbsp;N'************表的功能描述信息**********'&nbsp;AS&nbsp;N'表的功能描述信息';</li>
<li>--表的功能描述信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;ISNULL(value,&nbsp;'麻烦补齐表的功能描述信息')&nbsp;AS&nbsp;Table_Desc</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.extended_properties</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;major_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;minor_id&nbsp;=&nbsp;0</li>
<li>SELECT&nbsp;N'************表结构基本信息************'&nbsp;AS&nbsp;N'表结构基本信息';</li>
<li>--列出表结构的基本信息</li>
<li>SELECT&nbsp;&nbsp;C.Name&nbsp;AS&nbsp;Column_Nam&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;T.Name&nbsp;=&nbsp;'nvarchar'</li>
<li>THEN&nbsp;T.name&nbsp;+&nbsp;'('&nbsp;+&nbsp;CAST(C.max_length&nbsp;/&nbsp;2&nbsp;AS&nbsp;VARCHAR)&nbsp;+&nbsp;')'</li>
<li>ELSE&nbsp;T.name</li>
<li>END&nbsp;AS&nbsp;Data_Type&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;C.Max_Length&nbsp;=&nbsp;-1&nbsp;THEN&nbsp;'Max'</li>
<li>ELSE&nbsp;CAST(C.Max_Length&nbsp;AS&nbsp;VARCHAR)</li>
<li>END&nbsp;AS&nbsp;Max_Length&nbsp;,</li>
<li>C.Precision&nbsp;,</li>
<li>C.Scale&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;C.is_nullable&nbsp;=&nbsp;0&nbsp;THEN&nbsp;'&times;'</li>
<li>ELSE&nbsp;'&radic;'</li>
<li>END&nbsp;AS&nbsp;Is_Nullable&nbsp;,</li>
<li>ISNULL(CAST(I.seed_value&nbsp;AS&nbsp;VARCHAR)&nbsp;+&nbsp;'-'</li>
<li>+&nbsp;CAST(I.increment_value&nbsp;AS&nbsp;VARCHAR),&nbsp;'')&nbsp;AS&nbsp;Is_Identity&nbsp;,</li>
<li>ISNULL(M.text,&nbsp;'')&nbsp;AS&nbsp;Default_Value&nbsp;,</li>
<li>ISNULL(P.value,&nbsp;'')&nbsp;AS&nbsp;Column_Comments</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;sys.columns&nbsp;C</li>
<li>INNER&nbsp;JOIN&nbsp;sys.types&nbsp;T&nbsp;ON&nbsp;C.system_type_id&nbsp;=&nbsp;T.user_type_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;dbo.syscomments&nbsp;M&nbsp;ON&nbsp;M.id&nbsp;=&nbsp;C.default_object_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;sys.extended_properties&nbsp;P&nbsp;ON&nbsp;P.major_id&nbsp;=&nbsp;C.object_id</li>
<li>AND&nbsp;C.column_id&nbsp;=&nbsp;P.minor_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;sys.identity_columns&nbsp;I&nbsp;ON&nbsp;I.column_id&nbsp;=&nbsp;C.column_id</li>
<li>AND&nbsp;C.object_id&nbsp;=&nbsp;I.object_id</li>
<li>WHERE&nbsp;&nbsp;&nbsp;C.[object_id]&nbsp;=&nbsp;@ObjectId</li>
<li>ORDER&nbsp;BY&nbsp;C.Column_Id&nbsp;ASC;</li>
<li>SELECT&nbsp;N'**********表约束基本信息************'&nbsp;AS&nbsp;N'表约束基本信息';</li>
<li>--表的约束信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;name&nbsp;,</li>
<li>type</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.objects</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent_object_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;type&nbsp;IN(&nbsp;'C ',&nbsp;'PK',&nbsp;'UQ',&nbsp;'F ',&nbsp;'D '&nbsp;)&nbsp;;</li>
<li>SELECT&nbsp;N'********表的索引基本信息********'&nbsp;AS&nbsp;N'表的索引基本信息';</li>
<li>--&plusmn;表的索引信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;i.index_id&nbsp;,</li>
<li>i.data_space_id&nbsp;,</li>
<li>i.name&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;type&nbsp;=&nbsp;0&nbsp;THEN&nbsp;'堆'</li>
<li>WHEN&nbsp;type&nbsp;=&nbsp;1&nbsp;THEN&nbsp;'聚集索引'</li>
<li>WHEN&nbsp;type&nbsp;=&nbsp;2&nbsp;THEN&nbsp;'非聚集索引'</li>
<li>WHEN&nbsp;type&nbsp;=&nbsp;3&nbsp;THEN&nbsp;'XML'</li>
<li>WHEN&nbsp;TYPE&nbsp;=&nbsp;4&nbsp;THEN&nbsp;'空间'</li>
<li>END&nbsp;AS&nbsp;[type]&nbsp;,</li>
<li>i.ignore_dup_key&nbsp;,</li>
<li>i.is_unique&nbsp;,</li>
<li>i.is_hypothetical&nbsp;,</li>
<li>i.is_primary_key&nbsp;,</li>
<li>i.is_unique_constraint&nbsp;,</li>
<li>s.auto_created&nbsp;,</li>
<li>s.no_recompute</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.indexes&nbsp;i</li>
<li>JOIN&nbsp;sys.stats&nbsp;s&nbsp;ON&nbsp;i.object_id&nbsp;=&nbsp;s.object_id</li>
<li>AND&nbsp;i.index_id&nbsp;=&nbsp;s.stats_id</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;i.object_id&nbsp;=&nbsp;@ObjectId;</li>
<li>SELECT&nbsp;N'********索引包含那些字段********'&nbsp;AS&nbsp;'索引字段信息';</li>
<li>SELECT&nbsp;&nbsp;d.name,&nbsp;i.index_id,&nbsp;c.name</li>
<li>FROM&nbsp;&nbsp;&nbsp;sys.indexes&nbsp;d</li>
<li>INNER&nbsp;JOIN&nbsp;&nbsp;&nbsp;&nbsp;sys.index_columns&nbsp;i&nbsp;ON&nbsp;d.object_id&nbsp;=&nbsp;i.object_id</li>
<li>LEFT&nbsp;JOIN&nbsp;sys.columns&nbsp;c&nbsp;ON&nbsp;i.object_id&nbsp;=&nbsp;c.object_id</li>
<li>AND&nbsp;i.index_column_id&nbsp;=&nbsp;c.column_id</li>
<li>WHERE&nbsp;&nbsp;&nbsp;d.object_id&nbsp;=&nbsp;@ObjectId;</li>
<li>SELECT&nbsp;N'********表的触发器基本信息********'&nbsp;AS&nbsp;N'触发器信息';</li>
<li>--表的触发器信息</li>
<li>SELECT&nbsp;&nbsp;trigger_name&nbsp;=&nbsp;name&nbsp;,</li>
<li>trigger_owner&nbsp;=&nbsp;USER_NAME(OBJECTPROPERTY(object_id,&nbsp;'ownerid'))&nbsp;,</li>
<li>isupdate&nbsp;=&nbsp;OBJECTPROPERTY(object_id,&nbsp;'ExecIsUpdateTrigger')&nbsp;,</li>
<li>isdelete&nbsp;=&nbsp;OBJECTPROPERTY(object_id,&nbsp;'ExecIsDeleteTrigger')&nbsp;,</li>
<li>isinsert&nbsp;=&nbsp;OBJECTPROPERTY(object_id,&nbsp;'ExecIsInsertTrigger')&nbsp;,</li>
<li>isafter&nbsp;=&nbsp;OBJECTPROPERTY(object_id,&nbsp;'ExecIsAfterTrigger')&nbsp;,</li>
<li>isinsteadof&nbsp;=&nbsp;OBJECTPROPERTY(object_id,&nbsp;'ExecIsInsteadOfTrigger')&nbsp;,</li>
<li>trigger_schema&nbsp;=&nbsp;SCHEMA_NAME(schema_id)</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.objects</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent_object_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;type&nbsp;IN(&nbsp;'TR',&nbsp;'TA'&nbsp;)&nbsp;;</li>
<li>END</li>
<li>ELSE&nbsp;IF&nbsp;@Sysobj_Type&nbsp;='V'&nbsp;AND&nbsp;@ObjectId&nbsp;&gt;&nbsp;0</li>
<li>BEGIN</li>
<li>SELECT&nbsp;N'*********视图的功能描述信息**********'&nbsp;&nbsp;AS&nbsp;N'视图的功能描述信息';</li>
<li>--视图的功能描述信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;ISNULL(value,&nbsp;N'麻烦补齐描述该视图功能的信息')&nbsp;AS&nbsp;View_Desc</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.extended_properties</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;major_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;minor_id&nbsp;=&nbsp;0</li>
<li>SELECT&nbsp;'*************视图基本信息*****************'&nbsp;AS&nbsp;N'视图基本信息';</li>
<li>SELECT&nbsp;&nbsp;C.Name&nbsp;AS&nbsp;Column_Nam&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;T.Name&nbsp;=&nbsp;'nvarchar'</li>
<li>THEN&nbsp;T.name&nbsp;+&nbsp;'('&nbsp;+&nbsp;CAST(C.max_length&nbsp;/&nbsp;2&nbsp;AS&nbsp;VARCHAR)&nbsp;+&nbsp;')'</li>
<li>ELSE&nbsp;T.name</li>
<li>END&nbsp;AS&nbsp;Data_Type&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;C.Max_Length&nbsp;=&nbsp;-1&nbsp;THEN&nbsp;'Max'</li>
<li>ELSE&nbsp;CAST(C.Max_Length&nbsp;AS&nbsp;VARCHAR)</li>
<li>END&nbsp;AS&nbsp;Max_Length&nbsp;,</li>
<li>C.Precision&nbsp;,</li>
<li>C.Scale&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;,</li>
<li>CASE&nbsp;WHEN&nbsp;C.is_nullable&nbsp;=&nbsp;0&nbsp;THEN&nbsp;'&times;'</li>
<li>ELSE&nbsp;'&radic;'</li>
<li>END&nbsp;AS&nbsp;Is_Nullable&nbsp;,</li>
<li>ISNULL(CAST(I.seed_value&nbsp;AS&nbsp;VARCHAR)&nbsp;+&nbsp;'-'</li>
<li>+&nbsp;CAST(I.increment_value&nbsp;AS&nbsp;VARCHAR),&nbsp;'')&nbsp;AS&nbsp;Is_Identity&nbsp;,</li>
<li>ISNULL(M.text,&nbsp;'')&nbsp;AS&nbsp;Default_Value&nbsp;,</li>
<li>ISNULL(P.value,&nbsp;'')&nbsp;AS&nbsp;Column_Comments</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;sys.columns&nbsp;C</li>
<li>INNER&nbsp;JOIN&nbsp;sys.types&nbsp;T&nbsp;ON&nbsp;C.system_type_id&nbsp;=&nbsp;T.user_type_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;dbo.syscomments&nbsp;M&nbsp;ON&nbsp;M.id&nbsp;=&nbsp;C.default_object_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;sys.extended_properties&nbsp;P&nbsp;ON&nbsp;P.major_id&nbsp;=&nbsp;C.object_id</li>
<li>AND&nbsp;C.column_id&nbsp;=&nbsp;P.minor_id</li>
<li>LEFT&nbsp;&nbsp;JOIN&nbsp;sys.identity_columns&nbsp;I&nbsp;ON&nbsp;I.column_id&nbsp;=&nbsp;C.column_id</li>
<li>AND&nbsp;C.object_id&nbsp;=&nbsp;I.object_id</li>
<li>WHERE&nbsp;&nbsp;&nbsp;C.[object_id]&nbsp;=&nbsp;@ObjectId</li>
<li>ORDER&nbsp;BY&nbsp;C.Column_Id&nbsp;ASC;</li>
<li>SELECT&nbsp;'**********视图脚本***********'&nbsp;AS&nbsp;'视图脚本';</li>
<li>EXEC&nbsp;sp_helptext&nbsp;@ObjName;</li>
<li>END</li>
<li>ELSE&nbsp;IF&nbsp;@Sysobj_Type&nbsp;='P'&nbsp;AND&nbsp;@ObjectId&nbsp;&gt;&nbsp;0</li>
<li>BEGIN</li>
<li>SELECT&nbsp;N'*********描述存储过程功能信息**********'&nbsp;&nbsp;AS&nbsp;N'描述存储过程功能信息';</li>
<li>--存储过程的功能描述信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;ISNULL(value,&nbsp;N'麻烦补齐描述该存储过程功能的信息')&nbsp;AS&nbsp;View_Desc</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.extended_properties</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;major_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;minor_id&nbsp;=&nbsp;0;</li>
<li>EXEC&nbsp;sp_help&nbsp;&nbsp;@ObjName;</li>
<li>END</li>
<li>ELSE&nbsp;IF&nbsp;@Sysobj_Type&nbsp;IN('IF')&nbsp;AND&nbsp;@ObjectId&nbsp;&gt;&nbsp;0</li>
<li>BEGIN</li>
<li>SELECT&nbsp;N'*********描述自定义函数功能信息**********'&nbsp;&nbsp;AS&nbsp;N'描述自定义函数功能信息';</li>
<li>--描述自定义函数功能信息</li>
<li>SELECT&nbsp;&nbsp;&nbsp;&nbsp;ISNULL(value,&nbsp;N'麻烦补齐描述该自定义函数功能的信息')&nbsp;AS&nbsp;View_Desc</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys.extended_properties</li>
<li>WHERE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;major_id&nbsp;=&nbsp;@ObjectId</li>
<li>AND&nbsp;minor_id&nbsp;=&nbsp;0;</li>
<li>SELECT&nbsp;&nbsp;'Name'&nbsp;=&nbsp;o.name&nbsp;,</li>
<li>'Owner'&nbsp;=&nbsp;USER_NAME(OBJECTPROPERTY(object_id,&nbsp;'ownerid'))&nbsp;,</li>
<li>'Object_type'&nbsp;=&nbsp;SUBSTRING(v.name,&nbsp;5,&nbsp;31)</li>
<li>FROM&nbsp;&nbsp;&nbsp;&nbsp;sys.all_objects&nbsp;o&nbsp;,</li>
<li>master.dbo.spt_values&nbsp;v</li>
<li>WHERE&nbsp;&nbsp;o.object_id&nbsp;=@ObjectId&nbsp;AND&nbsp;&nbsp;o.type&nbsp;=&nbsp;SUBSTRING(v.name,&nbsp;1,&nbsp;2)&nbsp;COLLATE&nbsp;database_default</li>
<li>AND&nbsp;v.type&nbsp;=&nbsp;'O9T'</li>
<li>ORDER&nbsp;BY&nbsp;[Owner]&nbsp;ASC&nbsp;,</li>
<li>Object_type&nbsp;DESC&nbsp;,</li>
<li>Name&nbsp;ASC</li>
<li>END</li>
<li>GO</li></ol>
</div>
</div>
</div>
<p>接下来，我们新建一张表来看看效果如何，视图，存储过程、自定义函数就不大战篇幅去展示了，一个例子就OK了，有兴趣的，自己试试</p>
<div>
<div>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">SET ANSI_NULLS ON</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">SET QUOTED_IDENTIFIER ON</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">IF EXISTS(SELECT * FROM sysobjects WHERE id=OBJECT_ID(N'Employee') AND type='U')</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">    DROP TABLE dbo.Employee;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">GO </pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">CREATE TABLE Employee</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">(</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">    Employee_ID          INT  IDENTITY(1,1) ,</pre>
<pre class="prettyprint linenums">    Employee_Name        NVARCHAR(12)        ,</pre>
<pre class="prettyprint linenums">    Sex                     SMALLINT DEFAULT(1),</pre>
<pre class="prettyprint linenums">    Department_ID         INT                ,</pre>
<pre class="prettyprint linenums">    Salary                 FLOAT                ,</pre>
<pre class="prettyprint linenums">    WorkYear             INT                ,</pre>
<pre class="prettyprint linenums">    CONSTRAINT PK_Employee PRIMARY KEY(Employee_ID)</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">);</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'员工编号' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'Employee_ID'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'员工姓名' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'Employee_Name'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'性别' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'Sex'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'部门编号' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'Department_ID'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'薪水' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'Salary'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'工龄' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee', @level2type=N'COLUMN',@level2name=N'WorkYear'</pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'员工信息表' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Employee'</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">CREATE TRIGGER TR_Employee_Salary ON Employee</pre>
<pre class="prettyprint linenums"> AFTER INSERT</pre>
<pre class="prettyprint linenums">AS</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">DECLARE @Salary FLOAT;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">    SELECT @Salary = Salary FROM INSERTED;</pre>
<pre class="prettyprint linenums">    </pre>
<pre class="prettyprint linenums"> IF (@Salary &lt; 0) </pre>
<pre class="prettyprint linenums">    BEGIN</pre>
<pre class="prettyprint linenums">        RAISERROR('The Salary  Small than 0 ',10,1);</pre>
<pre class="prettyprint linenums">        ROLLBACK TRANSACTION;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">    END</pre>
<pre class="prettyprint linenums">        </pre>
<pre class="prettyprint linenums">GO</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">CREATE VIEW V_Employee</pre>
<pre class="prettyprint linenums">AS </pre>
<pre class="prettyprint linenums">    SELECT Employee_ID, Employee_Name, WorkYear FROM Employee</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'员工信息表' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'V_Employee'</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'给用户批量赋权限的存储过程' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'sp_authorize_right'</pre>
</div>
</div>
<p>执行存储过程，你可以获取表Employee的基本信息了，如下所示</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/73542/201305/21231506-f8a95f7f32c04f029dfaa5b394e26192.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4kwne9.html">（转）LINUX测试环境部署Redis（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2emvoq.html">Linux&sol;centos下安装riak</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zp0lx9.html">洛谷 洛谷 P1011 车站 Label：续命模拟QAQ 未知50分</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzk058.html">Android开发常见问题系列之一：eclipse中adb&period;exe启动失败或者无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnnklj8.html">Android&mdash;&mdash;android必看 各个控件属性（网上看到的文字，觉得挺好的，珍藏了）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05jjgq.html">WustOJ 1575 Gingers and Mints&lpar;快速幂 &plus; dfs &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1yenmq.html">linux下搭建svn本地服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojddvpq.html">mipi 调试经验（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopl13q.html">python小练习之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1wk1zq.html">CODEVS3269混合背包&plus;二进制优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0pvnq.html">AppImage格式安装包使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zx1d39.html">C&num; - 常用接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zwm7q.html">PAT 1152 Google Recruitment</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyyxn2q.html">Java核心技术及面试指南面试题，基本数据类型、封装类和运算操作的面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwproy8.html">koa-convert源码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjm7168.html">html5实现拖拽上传头像</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn10z3q.html">React-Native 之 生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p7xnr8.html">hdu-2159（完全背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk60p38.html">【洛谷】【线段树&plus;位运算】P2574 XOR的艺术</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve31419.html">windows下beautifulsoup使用lxml解析使用报错</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mexowrq.html">iOS开发证书和配置文件的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z6e1e9.html">CentOS7配置静态IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gexn7z8.html">算法8 五大查找之：二叉排序树&lpar;BSTree&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jvwmv8.html">Zabbix实战-简易教程--拓扑图（Maps）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1x132q.html">dotnet core cli 命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ygr68.html">meterpreter&lowbar;paranoid&lowbar;mode&period;sh允许用户安全上演&sol;无级连接Meterpreter经检查合格证书的处理程序正在连接到</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoxykdq.html">JavaScript数组forEach&lpar;&rpar;、map&lpar;&rpar;、reduce&lpar;&rpar;方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkxd5d8.html">SpringBoot（一）走进Springboot的世界</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yknyg8.html">javaScript事件流是什么？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z3nvx9.html">vue-cli脚手架的环境搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
